diff --git a/src/main/java/net/minecraft/core/net/command/commands/GiveCommand.java b/src/main/java/net/minecraft/core/net/command/commands/GiveCommand.java
index 777a6bc47..d9dba700c 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/GiveCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/GiveCommand.java
@@ -1,116 +1,84 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.client.entity.player.LocalPlayer;
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.arguments.IntegerArgumentType;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.server.entity.player.ServerPlayer;
-import net.minecraft.core.item.Item;
-import net.minecraft.core.item.Items;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.CommandHandler;
-import net.minecraft.core.net.command.CommandSender;
-import net.minecraft.core.net.command.PlayerCommandSender;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.arguments.ItemStackArgumentType;
+import net.minecraft.core.net.command.helpers.EntitySelector;
 
-public class GiveCommand extends Command{
+import java.util.List;
 
-	public GiveCommand() {
-		super("give", "item", "i");
-	}
+public class GiveCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("give")
+                .requires(CommandSource::hasAdmin)
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("target", EntityArgumentType.players())
+                        .then(RequiredArgumentBuilder.<CommandSource, ItemStack>argument("item", ItemStackArgumentType.itemStack())
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    ItemStack itemStack = c.getArgument("item", ItemStack.class);
+                                    int amount = itemStack.stackSize;
+                                    EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                                    List<? extends Entity> entities = entitySelector.get(source);
 
-	@Override
-	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		Player player;
-		Item item;
-		int count = 1;
-		int meta = 0;
-		
-		int arg = 0;
-		if(args.length == 0) return false;
-		
-		if(handler.playerExists(args[0])) {
-			player = handler.getPlayer(args[0]);
-			arg++;
-		}else {
-			player = sender.getPlayer();
-		}
-		
-		if(player == null) {
-			throw new CommandError("no player");
-		}
+                                    for (Entity player : entities) {
+                                        ((Player)player).inventory.insertItem(itemStack, true);
+                                        if (itemStack.stackSize > 0) {
+                                            ((Player)player).dropPlayerItem(itemStack);
+                                        }
+                                    }
 
-		String[] ids = args[arg].split(":");
-		
-		item = getItem(ids[0]);
-		if(item == null) {
-			throw new CommandError("Item not found: \""+ids[0]+"\"");
-		}
-		
-		if(ids.length > 1) {
-			meta = Integer.parseInt(ids[1]);
-		}
-		arg++;
-		
-		if(args.length > arg) {
-			count = Integer.parseInt(args[arg]);
-		}
+                                    if (entities.size() == 1) {
+                                        source.sendTranslatableMessage("command.commands.give.success_single_entity", CommandHelper.getEntityName(entities.get(0)), amount, itemStack.getDisplayName());
+                                    } else {
+                                        source.sendTranslatableMessage("command.commands.give.success_single_entity", entities.size(), amount, itemStack.getDisplayName());
+                                    }
 
-		ItemStack itemStack = new ItemStack(item, count, meta);
-		
-		return givePlayerItem(handler, sender, player, itemStack); 
-	}
+                                    return Command.SINGLE_SUCCESS;
+                                })
+                                .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("amount", IntegerArgumentType.integer(1, 6400))
+                                        .executes(c -> {
+                                            CommandSource source = c.getSource();
+                                            ItemStack itemStack = c.getArgument("item", ItemStack.class);
+                                            EntitySelector entitySelector = c.getArgument("target", EntitySelector.class);
+                                            List<? extends Entity> entities = entitySelector.get(source);
+                                            int amount = c.getArgument("amount", Integer.class);
 
-	@Override
-	public boolean opRequired(String[] args) {
-		return true;
-	}
+                                            for (Entity player : entities) {
+                                                int incompleteStack = amount % 64;
+                                                for (int i = 0; i < (amount - incompleteStack) / 64; i++) {
+                                                    ItemStack itemStack1 = ItemStack.copyItemStack(itemStack);
+                                                    itemStack1.stackSize = 64;
+                                                    ((Player) player).inventory.insertItem(itemStack1, true);
+                                                    if (itemStack1.stackSize > 0) {
+                                                        ((Player) player).dropPlayerItem(itemStack1);
+                                                    }
+                                                }
+                                                if (incompleteStack > 0) {
+                                                    ItemStack itemStack1 = ItemStack.copyItemStack(itemStack);
+                                                    itemStack1.stackSize = incompleteStack;
+                                                    ((Player) player).inventory.insertItem(itemStack1, true);
+                                                    if (itemStack1.stackSize > 0) {
+                                                        ((Player) player).dropPlayerItem(itemStack1);
+                                                    }
+                                                }
+                                            }
 
-	@Override
-	public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
-		sender.sendMessage("/give <Player> <ID:Meta> <Count>");
-		if(sender instanceof PlayerCommandSender) {
-			sender.sendMessage("/give <ID:Meta> <Count>");
-		}
-	}
-	
-	public static Item getItem(String id) {
-		try {
-			int i = Integer.parseInt(id);
-			return getItem(i);
-		}catch (Exception e) {
-			String id2 = "tile."+id;
-			String id3 = "item."+id;
-			for(Item item : Item.itemsList) {
-				if(item != null) {
-					if(item.getKey().equalsIgnoreCase(id)) return item;
-					if(item.getKey().equalsIgnoreCase(id2)) return item;
-					if(item.getKey().equalsIgnoreCase(id3)) return item;
-				}
-			}
-			return null;
-		}
-	}
-	
-	public static Item getItem(int id) {
-		return Item.itemsList[id];
-	}
-	
-	public static boolean givePlayerItem(CommandHandler handler, CommandSender sender, Player player, ItemStack item) {
-		if(player instanceof LocalPlayer) {
-			player.inventory.insertItem(item, true);
-			if(item.stackSize > 0) {
-				player.dropPlayerItem(item);
-			}
-			return true;
-		}
-		if(player instanceof ServerPlayer) {
-			handler.sendCommandFeedback(sender, "Gave "+item.stackSize+" of "+ item.getItemKey() +" to "+player.getDisplayName());
-			
-			ServerPlayer playerMP = (ServerPlayer) player;
-			playerMP.dropPlayerItem(item);
-			return true;
-		}
-		return false;
-	}
+                                            if (entities.size() == 1) {
+                                                source.sendTranslatableMessage("command.commands.give.success_single_entity", CommandHelper.getEntityName(entities.get(0)), amount, itemStack.getDisplayName());
+                                            } else {
+                                                source.sendTranslatableMessage("command.commands.give.success_single_entity", entities.size(), amount, itemStack.getDisplayName());
+                                            }
 
+                                            return Command.SINGLE_SUCCESS;
+                                        })))));
+    }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/HealCommand.java b/src/main/java/net/minecraft/core/net/command/commands/HealCommand.java
new file mode 100644
index 000000000..f11a5d3b6
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/HealCommand.java
@@ -0,0 +1,45 @@
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.arguments.IntegerArgumentType;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.world.World;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+
+import java.lang.reflect.InvocationTargetException;
+import java.util.List;
+
+public class HealCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("heal")
+                .requires(CommandSource::hasAdmin)
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("entities", EntityArgumentType.entities())
+                        .then(RequiredArgumentBuilder.<CommandSource, Integer>argument("amount", IntegerArgumentType.integer(0, 32768))
+                                .executes(c -> {
+                                    List<? extends Entity> entities = c.getArgument("entities", EntitySelector.class).get(c.getSource());
+                                    int amount = c.getArgument("amount", Integer.class);
+
+                                    int entitiesAffected = 0;
+                                    for (Entity entity : entities) {
+                                        if (entity instanceof Mob) {
+                                            int maxHealth = 20;
+                                            try {
+                                                maxHealth = ((Mob)entity.getClass().getConstructor(World.class).newInstance(c.getSource().getWorld())).getMaxHealth();
+                                            } catch (NoSuchMethodException | InvocationTargetException | InstantiationException | IllegalAccessException ignored) {
+                                            }
+                                            int originalHealth = ((Mob)entity).getHealth();
+                                            ((Mob)entity).setHealthRaw(MathHelper.clamp(((Mob)entity).getHealth() + amount, 0, maxHealth));
+                                            if (((Mob)entity).getHealth() != originalHealth) ++entitiesAffected;
+                                        }
+                                    }
+                                    c.getSource().sendTranslatableMessage("command.commands.heal.success_" + (entitiesAffected == 1 ? "single" : "multiple"), entitiesAffected);
+                                    return entitiesAffected;
+                                }))));
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/HelpCommand.java b/src/main/java/net/minecraft/core/net/command/commands/HelpCommand.java
index b8e7bc8e0..5119abc86 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/HelpCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/HelpCommand.java
@@ -1,82 +1,48 @@
 package net.minecraft.core.net.command.commands;
 
-import net.minecraft.core.net.command.ConsoleCommandSender;
-import net.minecraft.core.net.command.TextFormatting;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandError;
-import net.minecraft.core.net.command.CommandHandler;
-import net.minecraft.core.net.command.CommandSender;
-import net.minecraft.core.net.command.Commands;
-
-import java.util.ArrayList;
-import java.util.Comparator;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.ParseResults;
+import com.mojang.brigadier.arguments.StringArgumentType;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import com.mojang.brigadier.tree.CommandNode;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.util.Iterables;
+
+import java.util.Arrays;
 import java.util.List;
-
-public class HelpCommand extends Command{
-
-	public HelpCommand() {
-		super("help", "?");
-	}
-
-	@Override
-	public boolean execute(CommandHandler handler, CommandSender sender, String[] args) {
-		if(args.length == 1) {
-			Command command = Commands.getCommand(args[0]);
-			
-			if(command == null) {
-				throw new CommandError("Can't find command: \""+args[0]+"\"");
-			}
-			
-			if(!sender.isAdmin() && command.opRequired(args)) {
-				throw new CommandError("You don't have permission to use this command!");
-			}
-			if(command.getNames().size() > 1) {
-				StringBuilder aliasStr = new StringBuilder();
-				aliasStr.append(TextFormatting.LIGHT_GRAY).append("Aliases: ");
-				for(int i=0; i < command.getNames().size(); i++) {
-					if(i > 0) {
-						aliasStr.append(", ");
-					}
-					aliasStr.append(command.getNames().get(i));
-				}
-				sender.sendMessage(aliasStr.toString());
-			}
-			sender.sendMessage(TextFormatting.LIGHT_GRAY + "Syntax: ");
-			command.sendCommandSyntax(handler, sender);
-			
-			return true;
-		}
-		
-		StringBuilder commandsString = new StringBuilder();
-
-		List<Command> commandList = new ArrayList<>(Commands.commands);
-		commandList.sort(Comparator.comparing(Command::getName)); // Sort commands by name
-
-		for(Command command : commandList) {
-			if(sender.isAdmin() || !command.opRequired(null)) {
-				if (sender instanceof ConsoleCommandSender) {
-					commandsString.append("\n").append("*    ");
-				} else {
-					commandsString.append(", ");
-				}
-				commandsString.append(command.getName());
-			}
-		}
-		
-		commandsString = new StringBuilder(TextFormatting.LIGHT_GRAY + "Commands: " + TextFormatting.WHITE + commandsString.substring(2));
-		sender.sendMessage(commandsString.toString());
-		
-		return true;
-	}
-
-	@Override
-	public boolean opRequired(String[] args) {
-		return false;
-	}
-
-	@Override
-	public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
-		sender.sendMessage("/help");
-	}
-
+import java.util.Map;
+
+public class HelpCommand {
+    private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.help.exception_failure"));
+
+    public static void register(CommandDispatcher<CommandSource> commandDispatcher) {
+        commandDispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("help")
+            .executes(c -> {
+                CommandSource source = c.getSource();
+                Map<CommandNode<CommandSource>, String> map = commandDispatcher.getSmartUsage(commandDispatcher.getRoot(), source);
+                if (!source.messageMayBeMultiline()) {
+                    source.sendMessage("Cannot display help on single-line command source");
+                    return 0;
+                }
+                for (String string : map.values()) {
+                    source.sendMessage("/" + string);
+                }
+                return map.size();
+            })
+            .then(RequiredArgumentBuilder.<CommandSource, String>argument("command", StringArgumentType.greedyString())
+                .executes(commandContext -> {
+                    ParseResults<CommandSource> parseResults = commandDispatcher.parse(StringArgumentType.getString(commandContext, "command"), commandContext.getSource());
+                    if (parseResults.getContext().getNodes().isEmpty()) {
+                        throw FAILURE.create();
+                    }
+                    Map<CommandNode<CommandSource>, String> map = commandDispatcher.getSmartUsage(Iterables.getLast(parseResults.getContext().getNodes()).getNode(), commandContext.getSource());
+                    for (String string : map.values()) {
+                        commandContext.getSource().sendMessage("/" + parseResults.getReader().getString() + " " + string);
+                    }
+                    return map.size();
+                })));
+    }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/KillCommand.java b/src/main/java/net/minecraft/core/net/command/commands/KillCommand.java
index dbcbd88cf..13e5df255 100644
--- a/src/main/java/net/minecraft/core/net/command/commands/KillCommand.java
+++ b/src/main/java/net/minecraft/core/net/command/commands/KillCommand.java
@@ -1,48 +1,63 @@
 package net.minecraft.core.net.command.commands;
 
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.net.command.Command;
-import net.minecraft.core.net.command.CommandHandler;
-import net.minecraft.core.net.command.CommandSender;
-
-public class KillCommand extends Command
-{
-    public KillCommand() {
-        super("kill");
-    }
-
-    @Override
-    public boolean execute(CommandHandler handler, CommandSender sender, String[] args)
-    {
-        if (args.length == 0)
-        {
-            Player player = sender.getPlayer();
-            player.killPlayer();
-
-            sender.sendMessage("Killed player " + player.getDisplayName());
-            return true;
-        }
-        else if (args.length == 1)
-        {
-            Player player = handler.getPlayer(args[0]);
-            if (player == null) return false;
-
-            player.killPlayer();
-            sender.sendMessage("Killed player " + player.getDisplayName());
-            return true;
-        }
-
-        return false;
-    }
-
-    @Override
-    public boolean opRequired(String[] args) {
-        return true;
-    }
-
-    @Override
-    public void sendCommandSyntax(CommandHandler handler, CommandSender sender) {
-        sender.sendMessage("/kill");
-        sender.sendMessage("/kill <username>");
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.util.CommandHelper;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+
+import java.util.concurrent.CopyOnWriteArrayList;
+
+public class KillCommand {
+    private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.kill.exception_failure"));
+
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("kill")
+                .requires(CommandSource::hasAdmin)
+                .executes(c -> {
+                    CommandSource source = c.getSource();
+                    Player sender = source.getSender();
+
+                    if (sender == null) throw CommandExceptions.notInWorld().create();
+
+                    sender.killPlayer();
+
+                    source.sendTranslatableMessage("command.commands.kill.single_entity", sender.getDisplayName());
+
+                    return Command.SINGLE_SUCCESS;
+                })
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("entities", EntityArgumentType.entities())
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            EntitySelector entitySelector = c.getArgument("entities", EntitySelector.class);
+                            CopyOnWriteArrayList<? extends Entity> entities = new CopyOnWriteArrayList<>(entitySelector.get(source));
+
+                            int entityCount = entities.size();
+
+                            if (entityCount == 0) throw FAILURE.create();
+                            else if (entityCount == 1) source.sendTranslatableMessage("command.commands.kill.single_entity", CommandHelper.getEntityName(entities.get(0)));
+                            else source.sendTranslatableMessage("command.commands.kill.multiple_entities", entityCount);
+
+                            for (Entity entity : entities) {
+                                if (entity instanceof Player) {
+                                    ((Player) entity).killPlayer();
+                                } else if (entity instanceof Mob) {
+                                    entity.hurt(null, 100, null);
+                                } else {
+                                    entity.remove();
+                                }
+                            }
+
+                            return Command.SINGLE_SUCCESS;
+                        })));
     }
 }
diff --git a/src/main/java/net/minecraft/core/net/command/commands/MessageCommand.java b/src/main/java/net/minecraft/core/net/command/commands/MessageCommand.java
new file mode 100644
index 000000000..0d52eb076
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/MessageCommand.java
@@ -0,0 +1,48 @@
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.arguments.StringArgumentType;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.tree.CommandNode;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.net.command.TextFormatting;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.EntityArgumentType;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+import net.minecraft.core.util.helper.LoggedPrintStream;
+
+import java.util.List;
+
+public class MessageCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("message")
+                .then(RequiredArgumentBuilder.<CommandSource, EntitySelector>argument("targets", EntityArgumentType.players())
+                        .then(RequiredArgumentBuilder.<CommandSource, String>argument("message", StringArgumentType.greedyString())
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    EntitySelector entitySelector = c.getArgument("targets", EntitySelector.class);
+                                    String message = c.getArgument("message", String.class);
+
+                                    String senderName = source.getName();
+
+                                    List<? extends Entity> players = entitySelector.get(source);
+
+                                    for (Entity player : players) {
+                                        source.sendMessage(TextFormatting.LIGHT_GRAY.toString() + TextFormatting.ITALIC.toString() + I18n.getInstance().translateKeyAndFormat("command.commands.message.outgoing", LoggedPrintStream.removeColorCodes(((Player)player).getDisplayName()), message));
+                                        source.sendMessage((Player)player, TextFormatting.LIGHT_GRAY + (TextFormatting.ITALIC + I18n.getInstance().translateKeyAndFormat("command.commands.message.incoming", senderName, message)));
+                                    }
+
+                                    return Command.SINGLE_SUCCESS;
+                                }))));
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("msg")
+                .redirect(command));
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("whisper")
+                .redirect(command));
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("tell")
+                .redirect(command));
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/PlaceCommand.java b/src/main/java/net/minecraft/core/net/command/commands/PlaceCommand.java
new file mode 100644
index 000000000..5bb224441
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/PlaceCommand.java
@@ -0,0 +1,57 @@
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import com.mojang.brigadier.exceptions.SimpleCommandExceptionType;
+import com.mojang.brigadier.tree.CommandNode;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.world.LevelListener;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.generate.feature.WorldFeature;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.arguments.IntegerCoordinatesArgumentType;
+import net.minecraft.core.net.command.arguments.WorldFeatureArgumentType;
+import net.minecraft.core.net.command.exceptions.CommandExceptions;
+import net.minecraft.core.net.command.helpers.IntegerCoordinates;
+
+public class PlaceCommand {
+    private static final SimpleCommandExceptionType FAILURE = new SimpleCommandExceptionType(() -> I18n.getInstance().translateKey("command.commands.place.exception_failure"));
+
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        CommandNode<CommandSource> command = dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("place")
+                .requires(CommandSource::hasAdmin)
+                .then(RequiredArgumentBuilder.<CommandSource, WorldFeature>argument("feature", WorldFeatureArgumentType.worldFeature())
+                        .then(RequiredArgumentBuilder.<CommandSource, IntegerCoordinates>argument("position", IntegerCoordinatesArgumentType.intCoordinates())
+                                .executes(c -> {
+                                    CommandSource source = c.getSource();
+                                    WorldFeature feature = c.getArgument("feature", WorldFeature.class);
+                                    IntegerCoordinates coordinates = c.getArgument("position", IntegerCoordinates.class);
+                                    World world = source.getWorld();
+
+                                    if (coordinates == null) throw CommandExceptions.notInWorld().create();
+
+                                    int x = coordinates.getX(source);
+                                    int y = coordinates.getY(source, true);
+                                    int z = coordinates.getZ(source);
+
+                                    boolean success = feature.place(world, source.getWorld().rand, x, y, z);
+                                    if (success) {
+                                        for (LevelListener listener : world.listeners) {
+                                            listener.allChanged(true, false);
+                                        }
+                                        source.sendTranslatableMessage("command.commands.place.success", feature.getClass().getSimpleName().substring(12), x, y, z);
+                                    } else {
+                                        throw FAILURE.create();
+                                    }
+                                    return Command.SINGLE_SUCCESS;
+                                }))));
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("generate")
+                .requires(CommandSource::hasAdmin)
+                .redirect(command));
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("gen")
+                .requires(CommandSource::hasAdmin)
+                .redirect(command));
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/commands/SayCommand.java b/src/main/java/net/minecraft/core/net/command/commands/SayCommand.java
new file mode 100644
index 000000000..260d02158
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/commands/SayCommand.java
@@ -0,0 +1,23 @@
+package net.minecraft.core.net.command.commands;
+
+import com.mojang.brigadier.Command;
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.arguments.StringArgumentType;
+import com.mojang.brigadier.builder.LiteralArgumentBuilder;
+import com.mojang.brigadier.builder.RequiredArgumentBuilder;
+import net.minecraft.core.net.command.CommandSource;
+
+public class SayCommand {
+    public static void register(CommandDispatcher<CommandSource> dispatcher) {
+        dispatcher.register(LiteralArgumentBuilder.<CommandSource>literal("say")
+                .requires(CommandSource::hasAdmin)
+                .then(RequiredArgumentBuilder.<CommandSource, String>argument("message", StringArgumentType.greedyString())
+                        .executes(c -> {
+                            CommandSource source = c.getSource();
+                            String message = StringArgumentType.getString(c, "message");
+                            String senderName = source.getName();
+                            source.sendMessageToAllPlayers("[" + senderName + "§r] " + message);
+                            return Command.SINGLE_SUCCESS;
+                        })));
+    }
+}
